%module vtk
%include typemaps.i
%include vtk_typemaps.i
%include vtkCommon_typemaps.i


%{
#include "vtkLookupTable.h"
%}

%import vtkScalarsToColors.h
%import vtkUnsignedCharArray.h


%{
extern void vtkLookupTable_freefunc(void *ptr)
{
    vtkLookupTable *obj;
    obj = (vtkLookupTable*)ptr;
    obj->Delete();
}
%}

%typemap(ruby,out) double value[2] {
  int i;
  $result = rb_ary_new2(2);
  for (i=0; i<2; i++)
    rb_ary_store($result,i,rb_float_new($1[i]));
}
%apply double value[2]{
   double *GetTableRange()
}
%ignore GetTableRange(double data[2]);
%ignore GetTableRange(double _arg[2]);
%ignore GetTableRange(double &_arg1,double &_arg2);

%typemap(ruby,out) double value[2] {
  int i;
  $result = rb_ary_new2(2);
  for (i=0; i<2; i++)
    rb_ary_store($result,i,rb_float_new($1[i]));
}
%apply double value[2]{
   double *GetHueRange()
}
%ignore GetHueRange(double data[2]);
%ignore GetHueRange(double _arg[2]);
%ignore GetHueRange(double &_arg1,double &_arg2);

%typemap(ruby,out) double value[2] {
  int i;
  $result = rb_ary_new2(2);
  for (i=0; i<2; i++)
    rb_ary_store($result,i,rb_float_new($1[i]));
}
%apply double value[2]{
   double *GetSaturationRange()
}
%ignore GetSaturationRange(double data[2]);
%ignore GetSaturationRange(double _arg[2]);
%ignore GetSaturationRange(double &_arg1,double &_arg2);

%typemap(ruby,out) double value[2] {
  int i;
  $result = rb_ary_new2(2);
  for (i=0; i<2; i++)
    rb_ary_store($result,i,rb_float_new($1[i]));
}
%apply double value[2]{
   double *GetValueRange()
}
%ignore GetValueRange(double data[2]);
%ignore GetValueRange(double _arg[2]);
%ignore GetValueRange(double &_arg1,double &_arg2);

%typemap(ruby,out) double value[2] {
  int i;
  $result = rb_ary_new2(2);
  for (i=0; i<2; i++)
    rb_ary_store($result,i,rb_float_new($1[i]));
}
%apply double value[2]{
   double *GetAlphaRange()
}
%ignore GetAlphaRange(double data[2]);
%ignore GetAlphaRange(double _arg[2]);
%ignore GetAlphaRange(double &_arg1,double &_arg2);

%include vtkLookupTable.h
