%module vtk
%include typemaps.i
%include vtk_typemaps.i
%include vtkCommon_typemaps.i


%{
#include "vtkStructuredGrid.h"
#include "vtkEmptyCell.h"
#include "vtkHexahedron.h"
#include "vtkLine.h"
#include "vtkQuad.h"
#include "vtkStructuredVisibilityConstraint.h"
#include "vtkUnsignedCharArray.h"
#include "vtkVertex.h"
%}

%import vtkPointSet.h
%import vtkStructuredData.h


%{
extern void vtkStructuredGrid_freefunc(void *ptr)
{
    vtkStructuredGrid *obj;
    obj = (vtkStructuredGrid*)ptr;
    obj->Delete();
}
%}

%typemap(ruby,out) int value[6] {
  int i;
  $result = rb_ary_new2(6);
  for (i=0; i<6; i++)
    rb_ary_store($result,i,INT2NUM($1[i]));
}
%apply int value[6]{
   int *GetExtent()
}
%ignore GetExtent(int data[6]);
%ignore GetExtent(int _arg[6]);
%ignore GetExtent(int &_arg1,int &_arg2,int &_arg3,int &_arg4,int &_arg5,int &_arg6);

%include vtkStructuredGrid.h
