%module vtk
%include typemaps.i
%include vtk_typemaps.i
%include vtkRendering_typemaps.i


%{
#include "vtkLight.h"
#include "vtkRenderer.h"
%}

%import vtkObject.h


%{
extern void vtkLight_freefunc(void *ptr)
{
    vtkLight *obj;
    obj = (vtkLight*)ptr;
    obj->Delete();
}
%}

%typemap(ruby,out) double value[3] {
  int i;
  $result = rb_ary_new2(3);
  for (i=0; i<3; i++)
    rb_ary_store($result,i,rb_float_new($1[i]));
}
%apply double value[3]{
   double *GetAmbientColor()
}
%ignore GetAmbientColor(double data[3]);
%ignore GetAmbientColor(double _arg[3]);
%ignore GetAmbientColor(double &_arg1,double &_arg2,double &_arg3);

%typemap(ruby,out) double value[3] {
  int i;
  $result = rb_ary_new2(3);
  for (i=0; i<3; i++)
    rb_ary_store($result,i,rb_float_new($1[i]));
}
%apply double value[3]{
   double *GetDiffuseColor()
}
%ignore GetDiffuseColor(double data[3]);
%ignore GetDiffuseColor(double _arg[3]);
%ignore GetDiffuseColor(double &_arg1,double &_arg2,double &_arg3);

%typemap(ruby,out) double value[3] {
  int i;
  $result = rb_ary_new2(3);
  for (i=0; i<3; i++)
    rb_ary_store($result,i,rb_float_new($1[i]));
}
%apply double value[3]{
   double *GetSpecularColor()
}
%ignore GetSpecularColor(double data[3]);
%ignore GetSpecularColor(double _arg[3]);
%ignore GetSpecularColor(double &_arg1,double &_arg2,double &_arg3);

%typemap(ruby,out) double value[3] {
  int i;
  $result = rb_ary_new2(3);
  for (i=0; i<3; i++)
    rb_ary_store($result,i,rb_float_new($1[i]));
}
%apply double value[3]{
   double *GetPosition()
}
%ignore GetPosition(double data[3]);
%ignore GetPosition(double _arg[3]);
%ignore GetPosition(double &_arg1,double &_arg2,double &_arg3);

%typemap(ruby,out) double value[3] {
  int i;
  $result = rb_ary_new2(3);
  for (i=0; i<3; i++)
    rb_ary_store($result,i,rb_float_new($1[i]));
}
%apply double value[3]{
   double *GetFocalPoint()
}
%ignore GetFocalPoint(double data[3]);
%ignore GetFocalPoint(double _arg[3]);
%ignore GetFocalPoint(double &_arg1,double &_arg2,double &_arg3);

%typemap(ruby,out) double value[3] {
  int i;
  $result = rb_ary_new2(3);
  for (i=0; i<3; i++)
    rb_ary_store($result,i,rb_float_new($1[i]));
}
%apply double value[3]{
   double *GetAttenuationValues()
}
%ignore GetAttenuationValues(double data[3]);
%ignore GetAttenuationValues(double _arg[3]);
%ignore GetAttenuationValues(double &_arg1,double &_arg2,double &_arg3);

%include vtkLight.h
