%module vtk
%include typemaps.i
%include vtk_typemaps.i
%include vtkRendering_typemaps.i


%{
#include "vtkLightKit.h"
#include "vtkLight.h"
#include "vtkRenderer.h"
%}

%import vtkObject.h


%{
extern void vtkLightKit_freefunc(void *ptr)
{
    vtkLightKit *obj;
    obj = (vtkLightKit*)ptr;
    obj->Delete();
}
%}

%typemap(ruby,out) double value[3] {
  int i;
  $result = rb_ary_new2(3);
  for (i=0; i<3; i++)
    rb_ary_store($result,i,rb_float_new($1[i]));
}
%apply double value[3]{
   double *GetKeyLightColor()
}
%ignore GetKeyLightColor(double data[3]);
%ignore GetKeyLightColor(double _arg[3]);
%ignore GetKeyLightColor(double &_arg1,double &_arg2,double &_arg3);

%typemap(ruby,out) double value[3] {
  int i;
  $result = rb_ary_new2(3);
  for (i=0; i<3; i++)
    rb_ary_store($result,i,rb_float_new($1[i]));
}
%apply double value[3]{
   double *GetFillLightColor()
}
%ignore GetFillLightColor(double data[3]);
%ignore GetFillLightColor(double _arg[3]);
%ignore GetFillLightColor(double &_arg1,double &_arg2,double &_arg3);

%typemap(ruby,out) double value[3] {
  int i;
  $result = rb_ary_new2(3);
  for (i=0; i<3; i++)
    rb_ary_store($result,i,rb_float_new($1[i]));
}
%apply double value[3]{
   double *GetHeadlightColor()
}
%ignore GetHeadlightColor(double data[3]);
%ignore GetHeadlightColor(double _arg[3]);
%ignore GetHeadlightColor(double &_arg1,double &_arg2,double &_arg3);

%typemap(ruby,out) double value[3] {
  int i;
  $result = rb_ary_new2(3);
  for (i=0; i<3; i++)
    rb_ary_store($result,i,rb_float_new($1[i]));
}
%apply double value[3]{
   double *GetBackLightColor()
}
%ignore GetBackLightColor(double data[3]);
%ignore GetBackLightColor(double _arg[3]);
%ignore GetBackLightColor(double &_arg1,double &_arg2,double &_arg3);

%typemap(ruby,out) double value[2] {
  int i;
  $result = rb_ary_new2(2);
  for (i=0; i<2; i++)
    rb_ary_store($result,i,rb_float_new($1[i]));
}
%apply double value[2]{
   double *GetKeyLightAngle()
}
%ignore GetKeyLightAngle(double data[2]);
%ignore GetKeyLightAngle(double _arg[2]);
%ignore GetKeyLightAngle(double &_arg1,double &_arg2);

%typemap(ruby,out) double value[2] {
  int i;
  $result = rb_ary_new2(2);
  for (i=0; i<2; i++)
    rb_ary_store($result,i,rb_float_new($1[i]));
}
%apply double value[2]{
   double *GetFillLightAngle()
}
%ignore GetFillLightAngle(double data[2]);
%ignore GetFillLightAngle(double _arg[2]);
%ignore GetFillLightAngle(double &_arg1,double &_arg2);

%typemap(ruby,out) double value[2] {
  int i;
  $result = rb_ary_new2(2);
  for (i=0; i<2; i++)
    rb_ary_store($result,i,rb_float_new($1[i]));
}
%apply double value[2]{
   double *GetBackLightAngle()
}
%ignore GetBackLightAngle(double data[2]);
%ignore GetBackLightAngle(double _arg[2]);
%ignore GetBackLightAngle(double &_arg1,double &_arg2);

%include vtkLightKit.h
